
registers       STRUC          ;                A structure is a table of
xEDI             DD      ?     ; [ESP]          OFFSETS and TYPES. Normally
xESI             DD      ?     ; [ESP]+4        when a structure is used to
xEBP             DD      ?     ; [ESP]+8        access the stack frame the
xESP             DD      ?     ; [ESP]+12       BP register is used as stack
xEBX             DD      ?     ; [ESP]+16       marker. However, if we do not
xEDX             DD      ?     ; [ESP]+20       plan to use ESP we can cheat
xECX             DD      ?     ; [ESP]+24       and use that as a stack marker.
xEAX             DD      ?     ; [ESP]+28
registers       ENDS

Message_EAX     DB      CR,LF,'  EAX = ',0
Message_EBX     DB      ' EBX = ',0
Message_ECX     DB      ' ECX = ',0
Message_EDX     DB      ' EDX = ',0
Message_ESI     DB      ' ESI = ',0
Message_EDI     DB      ' EDI = ',0
Message_EBP     DB      ' EBP = ',0
Message_ESP     DB      CR,LF,'  ESP = ',0
Message_CS      DB      CR,LF,'  CS = ',0
Message_DS      DB      ' DS = ',0
Message_ES      DB      ' ES = ',0
Message_FS      DB      ' FS = ',0
Message_GS      DB      ' GS = ',0
Message_SS      DB      ' SS = ',0

PRINT_AREGS      proc   near                    ; save all general 32-bit registers
                 PUSHAD                         ; save all general 32-bit registers
                 MOV    DI, OFFSET Message_EAX  ; Print " EAX="
                 CALL   Print                   ;
                 MOV    EAX, [ESP].xEAX         ; The "." is a structure reference.
                 CALL   SerOut32         ; Print the contents of EAX from the Stack

                 MOV    DI, OFFSET Message_EBX
                 CALL   Print
                 MOV    EAX, [ESP].xEBX
                 CALL   SerOut32

                 MOV    DI, OFFSET Message_ECX
                 CALL   Print
                 MOV    EAX, [ESP].xECX
                 CALL   SerOut32

                 MOV    DI, OFFSET Message_EDX
                 CALL   Print
                 MOV    EAX, [ESP].xEDX
                 CALL   SerOut32

                 MOV    DI, OFFSET Message_ESP
                 CALL   Print
                 MOV    EAX, [ESP].xESP
                 CALL   SerOut32

                 MOV    DI, OFFSET Message_EBP
                 CALL   Print
                 MOV    EAX, [ESP].xEBP
                 CALL   SerOut32

                 MOV    DI, OFFSET Message_ESI
                 CALL   Print
                 MOV    EAX, [ESP].xESI
                 CALL   SerOut32

                 MOV    DI, OFFSET Message_EDI
                 CALL   Print
                 MOV    EAX, [ESP].xEDI
                 CALL   SerOut32

                 MOV    DI, OFFSET Message_CS
                 CALL   Print
                 MOV    AX, CS
                 CALL   SerOut16

                 MOV    DI, OFFSET Message_DS
                 CALL   Print
                 MOV    AX, DS
                 CALL   SerOut16

                 MOV    DI, OFFSET Message_ES
                 CALL   Print
                 MOV    AX, ES
                 CALL   SerOut16

                 MOV    DI, OFFSET Message_FS
                 CALL   Print
                 MOV    AX, FS
                 CALL   SerOut16

                 MOV    DI, OFFSET Message_GS
                 CALL   Print
                 MOV    AX, GS
                 CALL   SerOut16

                 MOV    DI, OFFSET Message_SS
                 CALL   Print
                 MOV    AX, SS
                 CALL   SerOut16

pend:            POPAD
                 RET
PRINT_AREGS      endp                           ; save all general 32-bit registers
